////////////////////////////////////////////////////////////////////////////////
// Converter PSX TIM - > TGA
// (C) faceH0r 14.08.2006
////////////////////////////////////////////////////////////////////////////////

#include	<windows.h>

#include		<stdio.h>
#include		<conio.h>

#include		<fcntl.h>
#include		<io.h>
#include		<sys/stat.h>

typedef struct	_TgaHeader
{
	unsigned char		chType;
	unsigned char		chColor;
	unsigned char		chImage;
	unsigned char		uiColorMap[ 5 ];
	unsigned short		usOrX;
	unsigned short		usOrY;
	unsigned short		usWidth;
	unsigned short		usHeight;
	unsigned char		chBPP;
	unsigned char		chInfo;
}				TgaHeader;

typedef struct	_stRGB
{
	char		ch[ 3 ];
}				stRGB;

int main( int argc, char * argv[] )
{
	char		sNameInput[ 256 ], sNameOutput[ 256 ];
	
	memset( sNameInput, 0, 255 );
	memset( sNameOutput, 0, 255 );
	
	if( argc < 2 )
	{
		printf( "Enter file - > \n" );
		scanf( "%s", sNameInput );
	}
	else
	{
		memcpy( sNameInput, argv[ 1 ], strlen( argv[ 1 ] ) );
	}
	
	memcpy( sNameOutput, sNameInput, strlen( sNameInput ) );
	strcat( sNameOutput, ".tga" );
	
	int inpf = open( sNameInput, O_RDONLY | O_BINARY );
	
	unsigned short	iW = 0;
	unsigned short	iH = 0;
	unsigned int	iS;
	short	* sB;
	stRGB	* sR;
	
	TgaHeader	hTga = { 0 };
	
	if( inpf != - 1 )
	{
		lseek( inpf, 16, SEEK_SET );
	
		read( inpf, &iW, 2 );
		read( inpf, &iH, 2 );

		iS = iW * iH;
	
		hTga.chImage  = 2;
		hTga.chInfo   = 0x20;
		hTga.usWidth  = iW;
		hTga.usHeight = iH;
		hTga.chBPP    = 24;
		
		sB = new short[ iS ];
		read( inpf, sB, 2 * iS );
		sR = new stRGB[ iS ];
	
		int outf = open( sNameOutput, O_TRUNC | O_BINARY | O_WRONLY | O_CREAT, S_IWRITE );
	
		write( outf, &hTga, sizeof( hTga ) );
	
		for( int x = 0; x < iS; x ++ )
		{
			sR[ x ].ch[ 2 ] = ( sB[ x ] & 0x1F ) << 3;
			sR[ x ].ch[ 1 ] = ( ( sB[ x ] >> 5 ) & 0x1F ) << 3;
			sR[ x ].ch[ 0 ] = ( ( sB[ x ] >> 10 ) & 0x1F ) << 3;
		}
		
		write( outf, sR, 3 * iS );
		
		delete [] sR;
		delete [] sB;

		close( outf );

		close( inpf );
		
		printf( "It's done\n" );
	}
	else
	{
		printf( "File not found\n" );
	}
	
	printf( "Press any key to exit..." );
	getch();
	
	return 0;
}
